//-------------------
// ToDo
// 
// 1. HBITMAP to Image File : - ڵ   ȭ
//                            - bmp ̿ܿ jpg, png ϵ 
// 2. Hooking :    ʴ μ
//-------------------
// EasyClipperDlg.cpp :  
//

#include "stdafx.h"
#include "EasyClipper.h"
#include "EasyClipperDlg.h"
#include "KeyboardHook.h"
#include "CanvasDlg.h"
#include "base64.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// Window Handle
HWND m_hMainWnd;
BOOL g_IsCaptureMode = FALSE;
BOOL m_bIsSaveMode = FALSE;

// CEasyClipperDlg ȭ 
CEasyClipperDlg::CEasyClipperDlg(CWnd* pParent /*=NULL*/)
: CDialog(CEasyClipperDlg::IDD, pParent)
, m_IsTrayIcon(false)
, m_ImageCaptured(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_ImageCaptured = FALSE;
	m_hCaptureBitmap = NULL;
}

void CEasyClipperDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CEasyClipperDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_TRAY_ICON, OnTrayNotify)
	ON_MESSAGE(WM_WIN_C, OnWinCPressed)
	ON_MESSAGE(WM_WIN_V, OnWinVPressed)
	ON_MESSAGE(WM_CTRL_V,OnCtrlCPressed)
	ON_WM_DESTROY()
	ON_WM_WINDOWPOSCHANGING()
END_MESSAGE_MAP()


// CEasyClipperDlg ޽ ó

BOOL CEasyClipperDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	HANDLE hEvent = CreateEvent(NULL, FALSE, TRUE, AfxGetAppName());
	if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
		//AfxMessageBox("̹ α׷ Դϴ.");
		PostQuitMessage(WM_QUIT);
	}


	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.
	m_hMainWnd = AfxGetMainWnd()->m_hWnd;

	m_IsTrayIcon = false;
	RegistTrayIcon();

	// clsid ʱȭ
	GetEncoderClsid(L"image/jpeg", &m_jpegClsid);
	GetEncoderClsid(L"image/bmp", &m_bmpClsid);
	GetEncoderClsid(L"image/png", &m_pngClsid);

	StartHook(KeyboardHookProc);

	// ֻ 
	//::SetWindowPos(GetSafeHwnd(),  HWND_TOPMOST , 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ. /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CEasyClipperDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮ

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CEasyClipperDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


// TrayMode  ȯ
void CEasyClipperDlg::RegistTrayIcon(void)
{
	if(m_IsTrayIcon == true) { return; }

	nid.cbSize = sizeof(nid);
	nid.hWnd = m_hWnd; //   ڵ
	nid.uID = IDR_MAINFRAME;  //  ҽ ID
	nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP; // ÷ 
	nid.uCallbackMessage = WM_TRAY_ICON;
	nid.hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME); //  ε
	lstrcpy(nid.szTip, L"EasyClipper"); 
	Shell_NotifyIcon(NIM_ADD, &nid);
	SendMessage(WM_SETICON, (WPARAM)TRUE, (LPARAM)nid.hIcon);
	m_IsTrayIcon = TRUE;
}

void CEasyClipperDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	if(m_IsTrayIcon) //  Ʈ  Ǿ Ȯ 
	{
		// ۾ ǥ(TaskBar)    Ѵ.
		Shell_NotifyIcon(NIM_DELETE, &nid);
	}

	// ŷ 
	StopHook();

	//  Bitmap ҽ 
	if(m_hCaptureBitmap != NULL) {
		DeleteObject(m_hCaptureBitmap);
		m_hCaptureBitmap = NULL;
	}
}

void CEasyClipperDlg::OnWindowPosChanging(WINDOWPOS* lpwndpos)
{
	// 
	lpwndpos->flags &= ~SWP_SHOWWINDOW;

	CDialog::OnWindowPosChanging(lpwndpos);

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
}

LRESULT CEasyClipperDlg::OnTrayNotify(WPARAM wParam, LPARAM lParam)
{
	if(LOWORD(lParam) == WM_RBUTTONDOWN) {
		CMenu menuTemp, *pContextMenu;
		CPoint pt;
		GetCursorPos(&pt);
		if(menuTemp.LoadMenuW(IDR_MENU))
		{
			pContextMenu = menuTemp.GetSubMenu(0);
			this->SetForegroundWindow(); // to make hide the menu when a user click outside of the menu
			pContextMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON, pt.x, pt.y, this, NULL);
			this->PostMessage(WM_NULL, 0, 0); // restore state
		}
	}
	return 1;
}


// Keyboard Hook Proc
LRESULT CALLBACK KeyboardHookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	// 0  
	if(nCode < 0) { return 1; }
	int return_code = 1;

	// Ű 
	DWORD vKey = ((tagKBDLLHOOKSTRUCT *)lParam)->vkCode;

	// ESC  
	if(vKey != VK_ESCAPE && g_IsCaptureMode == TRUE) { return 1; }

	switch(wParam) {
		case WM_KEYDOWN:
			//  Ű Բ  쿡
			if(GetAsyncKeyState(VK_LWIN) != NULL) {
				if(vKey == 0x43 && g_IsCaptureMode == FALSE && m_bIsSaveMode == FALSE) {	// Win + C
					//g_IsCaptureMode = TRUE;
					PostMessage(m_hMainWnd, WM_WIN_C, wParam, lParam);
					//return_code = -1;
				} else if(vKey == 0x56 && g_IsCaptureMode == FALSE && m_bIsSaveMode == FALSE) {	// Win + V
					PostMessage(m_hMainWnd, WM_WIN_V, wParam, lParam);
					//return_code = -1;
				}
			}
			break;
	}
	return return_code;
}



LRESULT CEasyClipperDlg::OnWinCPressed(WPARAM wParam, LPARAM lParam)
{
	g_IsCaptureMode = TRUE;

	// Mode Check
	if(g_IsCaptureMode == FALSE || m_bIsSaveMode == TRUE) { return 1; }

	// Canvas Display
	CanvasDlg canvas;
	canvas.DoModal();

	// Clip Area
	RECT area = canvas.GetClipRect();
	if((area.bottom | area.left | area.right | area.top) != 0) {
		ScreenCapture(area);
		SaveToClipboard();
		m_ImageCaptured = TRUE;
	} else {
		m_ImageCaptured = FALSE;
	}

	g_IsCaptureMode = FALSE;
	return 1;
}


LRESULT CEasyClipperDlg::OnWinVPressed(WPARAM wParam, LPARAM lParam)
{
	// Capture  Image   
	if(m_ImageCaptured == FALSE || m_bIsSaveMode == TRUE) { return 1; }
	m_bIsSaveMode = TRUE;

	// Dialog  ֻ ø
	if(::GetForegroundWindow() != this->m_hWnd){ 
		HWND h_active_wnd = ::GetForegroundWindow(); 
		if(h_active_wnd != NULL){ 
			DWORD thread_id = GetWindowThreadProcessId(h_active_wnd, NULL); 
			DWORD current_thread_id = GetCurrentThreadId(); 
			if(current_thread_id != thread_id){ 
				if(AttachThreadInput(current_thread_id, thread_id, TRUE)){ 
					BringWindowToTop(); 
					AttachThreadInput(current_thread_id, thread_id, FALSE); 
				} 
			} 
		} 
	}
	
	// File Dialog
	CFileDialog dlg(FALSE, NULL, NULL, OFN_EXPLORER | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,  _T("JPEG (*.jpg)|*.jpg|PNG (*.png)|*.png|Bitmap (*.bmp)|*.bmp||"), this, 0, 0);
	if(dlg.DoModal() == IDOK) {
		CString fileName = dlg.GetPathName();
		switch(dlg.m_pOFN->nFilterIndex) {
			case 1:	fileName.Append(_T(".jpg")); SaveImage(fileName, m_jpegClsid); break;
			case 2: fileName.Append(_T(".png")); SaveImage(fileName, m_pngClsid); break;
			case 3: fileName.Append(_T(".bmp")); SaveImage(fileName, m_bmpClsid); break;
		}
	}

	m_bIsSaveMode = FALSE;
	return 1;
}

LRESULT CEasyClipperDlg::OnCtrlCPressed(WPARAM wParam, LPARAM lParam)
{
	//MessageBoxW(L"Hook", L"Test", NULL);
	return 1;
}


BOOL CEasyClipperDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch(wParam) {
		case ID_EXIT: DestroyWindow(); break;
	}
	return 0;
}



void CEasyClipperDlg::ScreenCapture(RECT area)
{
	//  Bitmap ҽ 
	if(m_hCaptureBitmap != NULL) {
		DeleteObject(m_hCaptureBitmap);
		m_hCaptureBitmap = NULL;
	}

	// Capture
	int nClipWidth = area.right - area.left;
	int nClipHeight = area.bottom - area.top;

	HWND hDesktopWnd = ::GetDesktopWindow();
	HDC hDesktopDC = ::GetDC(hDesktopWnd);
    HDC hCaptureDC = CreateCompatibleDC(hDesktopDC);
    m_hCaptureBitmap =CreateCompatibleBitmap(hDesktopDC, 
                            nClipWidth, nClipHeight);
	::SelectObject(hCaptureDC,m_hCaptureBitmap); 
	::BitBlt(hCaptureDC,0,0,nClipWidth,nClipHeight,
		hDesktopDC,area.left,area.top,SRCCOPY|CAPTUREBLT);

	// ҽ 
	::ReleaseDC(hDesktopWnd,hDesktopDC);
    DeleteDC(hCaptureDC);
}



BOOL CEasyClipperDlg::SaveImage(LPCWSTR filePath, CLSID clsid)
{
	// ̹  .
	if(m_hCaptureBitmap == NULL) { return FALSE; }

	// Image 
	HPALETTE hpal; //ȷƮ 
	hpal = (HPALETTE)GetStockObject(DEFAULT_PALETTE);
	Gdiplus::Bitmap image(m_hCaptureBitmap, hpal);
	image.Save(filePath, &clsid, NULL);

	return TRUE;
}






void CEasyClipperDlg::HtmlToClipboard(const char *html) {
	// Create temporary buffer for HTML header...
	char *buf = new char[400 + strlen(html)];
	if (!buf) return;

	// Get clipboard id for HTML format...
	static int cfid = 0;
	if (!cfid) cfid = RegisterClipboardFormat(L"HTML Format");

	// Create a template string for the HTML header...
	strcpy(buf,
		"Version:0.9\r\n"
		"StartHTML:00000000\r\n"
		"EndHTML:00000000\r\n"
		"StartFragment:00000000\r\n"
		"EndFragment:00000000\r\n"
		"<html><body>\r\n"
		"<!--StartFragment -->\r\n");

	// Append the HTML...
	strcat(buf, html);
	strcat(buf, "\r\n");
	// Finish up the HTML format...
	strcat(buf,
		"<!--EndFragment-->\r\n"
		"</body>\r\n"
		"</html>");

	// Now go back, calculate all the lengths, and write out the
	// necessary header information. Note, wsprintf() truncates the
	// string when you overwrite it so you follow up with code to replace
	// the 0 appended at the end with a '\r'...
	char *ptr = strstr(buf, "StartHTML");
	sprintf(ptr + 10, "%08u", strstr(buf, "<html>") - buf);
	*(ptr + 10 + 8) = '\r';

	ptr = strstr(buf, "EndHTML");
	sprintf(ptr + 8, "%08u", strlen(buf));
	*(ptr + 8 + 8) = '\r';

	ptr = strstr(buf, "StartFragment");
	sprintf(ptr + 14, "%08u", strstr(buf, "<!--StartFrag") - buf);
	*(ptr + 14 + 8) = '\r';

	ptr = strstr(buf, "EndFragment");
	sprintf(ptr + 12, "%08u", strstr(buf, "<!--EndFrag") - buf);
	*(ptr + 12 + 8) = '\r';

	// Now you have everything in place ready to put on the
	// clipboard.

	// Allocate global memory for transfer...
	HGLOBAL hText = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, strlen(buf) + 4);

	// Put your string in the global memory...
	char *ptr2 = (char *)GlobalLock(hText);
	strcpy(ptr2, buf);
	GlobalUnlock(hText);

	::SetClipboardData(cfid, hText);

	CloseClipboard();

	// Free memory...
	GlobalFree(hText);

	// Clean up...
	delete[] buf;
}




BOOL CEasyClipperDlg::SaveToClipboard(void)
{
	if (m_hCaptureBitmap == NULL) { return FALSE; }

	if (OpenClipboard()) {
		EmptyClipboard();

		// bitmap
		SetClipboardData(CF_BITMAP, m_hCaptureBitmap);

		// html
		IStream* oStream = NULL;
		CreateStreamOnHGlobal(NULL, TRUE, (LPSTREAM*)&oStream);

		CLSID tiffClsid;
		HPALETTE hpal; //ȷƮ 
		hpal = (HPALETTE)GetStockObject(DEFAULT_PALETTE);
		Gdiplus::Bitmap image(m_hCaptureBitmap, hpal);
		image.Save(oStream, &m_pngClsid);

		ULARGE_INTEGER ulnSize;
		LARGE_INTEGER lnOffset;
		lnOffset.QuadPart = 0;
		oStream->Seek(lnOffset, STREAM_SEEK_END, &ulnSize);
		oStream->Seek(lnOffset, STREAM_SEEK_SET, NULL);

		char *pBuff = new char[(unsigned int)ulnSize.QuadPart];
		ULONG ulBytesRead;
		oStream->Read(pBuff, (ULONG)ulnSize.QuadPart, &ulBytesRead);

		std::string base64 = base64_encode((const unsigned char*)pBuff, ulnSize.QuadPart);
		base64 = base64.insert(0, "<img src='data:image/png;base64,");
		base64 = base64.append("'/>");

		// Use the data here
		HtmlToClipboard(base64.c_str());

		// release
		CloseClipboard();

		oStream->Release();
		delete pBuff;
		DeleteObject(hpal);

		return TRUE;
	}
	return FALSE;
}





int CEasyClipperDlg::GetEncoderClsid(const WCHAR* format, CLSID*  pClsid)
{
	UINT  num = 0;          // number of image encoders
	UINT  size = 0;         // size of the image encoder array in bytes

	Gdiplus::ImageCodecInfo* pImageCodecInfo = NULL;

	Gdiplus::GetImageEncodersSize(&num, &size);
	if(size == 0)
		return -1;  // Failure

	pImageCodecInfo = (Gdiplus::ImageCodecInfo*)(malloc(size));
	if(pImageCodecInfo == NULL)
		return -1;  // Failure

	Gdiplus::GetImageEncoders(num, size, pImageCodecInfo);

	for(UINT j = 0; j < num; ++j)
	{
		if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
		{
			*pClsid = pImageCodecInfo[j].Clsid;
			free(pImageCodecInfo);
			return j;  // Success
		}    
	}

	free(pImageCodecInfo);
	return -1;  // Failure
}
